           (*-------------------------------------------*
            |                   Test                    |
            |        CSP-Prover on Isabelle2005         |
            |               November 2005               |
            |                                           |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Test_finite = CSP_F:

(*****************************************************************

         1. simple example for MU operator (simple recursion)
         2. 
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                         event
 *********************************************************)

datatype Event = a | b | c

(*********************************************************
            specification SPC and system IMP
 *********************************************************)

consts 
  Spc :: "Event proc"
  Imp :: "Event proc"

defs
  Spc_def: "Spc == (MU X .. a -> X |~| b -> (MU Y .. a -> X |~| c -> Y))"
  Imp_def: "Imp == (MU X .. a -> b -> a -> X [+] b -> c -> a -> X)"

(*********************************************************
                   ? SPC <=F IMP ?
 *********************************************************)

lemma "Spc <=F Imp"
apply (simp add: Spc_def Imp_def)

apply (rule cspF_fp_induct_MU_right)   (* by fixed point induction *)
apply (simp)                           (* ProcX *)

apply (tactic {* cspF_unwind_tac 1 *}) (* unwind MU *)
apply (rule cspF_Ext_choice_right)     (* decompose [+] *)

(* sequence 1 *)

(* step 0 *)
apply (rule cspF_Int_choice_left1)     (* select the 1st one of |~| *)
apply (rule)
apply (simp)

(* step 1 *)
apply (tactic {* cspF_unwind_tac 1 *})
apply (rule cspF_Int_choice_left2)     (* select the 2nd one of |~| *)
apply (rule)
apply (simp)

(* step 2 *)
apply (tactic {* cspF_unwind_tac 1 *})
apply (rule cspF_Int_choice_left1)
apply (simp)

(* sequence 2 *)

(* step 0 *)
apply (rule cspF_Int_choice_left2)
apply (rule)
apply (simp)

(* step 1 *)
apply (tactic {* cspF_unwind_tac 1 *})
apply (rule cspF_Int_choice_left2)
apply (rule)
apply (simp)

(* step 2 *)
apply (tactic {* cspF_unwind_tac 1 *})
apply (rule cspF_Int_choice_left1)
apply (simp)
done

end
